; batch-pixelize-indexed.scm
; by Rob Antonishen
; http://ffaat.pointclark.net

; Version 1.0 (20090404)

; Description
;
; Script to batch convert files into .pat files
;

; License:
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURvarPosE.  See the
; GNU General Public License for more details.
;
; The GNU Public License is available at
; http://www.gnu.org/copyleft/gpl.html
(define (batch-pixelize-indexed inDir inLoadType outDir inSaveType inPixSize inColours)
									 
  (let*
    (
      (varLoadStr "")
      (varSaveStr "")
	  (varFileList 0)
    )
    ;begin here
    (set! varLoadStr
	  (cond 
		(( equal? inLoadType 0 ) ".jpg" )
		(( equal? inLoadType 1 ) ".bmp" )
		(( equal? inLoadType 2 ) ".png" )
		(( equal? inLoadType 3 ) ".gif" )
	  )
    )  

    (set! varSaveStr
	  (cond 
		(( equal? inSaveType 0 ) ".bmp" )
		(( equal? inSaveType 1 ) ".png" )
		(( equal? inSaveType 2 ) ".gif" )
	  )
    )  
    

    (set! varFileList (cadr (file-glob (string-append inDir "\\*" varLoadStr)  1)))
	
    (while (not (null? varFileList))
      (let* ((filename (car varFileList))
	         (short_filename (substring filename (+ (string-length inDir) 1) (- (string-length filename) 4)))
             (image (car (gimp-file-load RUN-NONINTERACTIVE filename filename)))
             (drawable (car (gimp-image-get-active-layer image)))
		     (newfilename (string-append outDir "\\" short_filename varSaveStr))
		    )
		
		  ;(gimp-message (string-append "Working on ->" filename))
		  ;(gimp-message (string-append "Now ->" newfilename))
		  
          (plug-in-pixelize RUN-NONINTERACTIVE image drawable inPixSize)
          (gimp-image-convert-indexed image NO-DITHER MAKE-PALETTE inColours FALSE FALSE "0")
          
          (gimp-file-save RUN-NONINTERACTIVE image drawable newfilename newfilename)

          (gimp-image-delete image)
	  )
	  (set! varFileList (cdr varFileList))
	)
	
  )  
)
  
(script-fu-register "batch-pixelize-indexed"
					"<Toolbox>/Xtns/Batch Pixelize and Convert to Indexed..."
					"Convert all files in a directory to pixelized, reducced colur images."
					"Rob Antonishen"
					"Rob Antonishen"
					"April 2009"
					""
					SF-DIRNAME    "Load from" ""
					SF-OPTION     "Load File Type" (list "jpg" "bmp" "png" "gif")
					SF-DIRNAME    "Save to" ""
					SF-OPTION     "Save File Type" (list "bmp" "png" "gif")
                    SF-ADJUSTMENT "Pixelate Size"  (list 16 2 100 1 10 1 SF-SLIDER)                    
                    SF-ADJUSTMENT "Colours"        (list 16 2 100 1 10 1 SF-SLIDER)                    
)
